/*
 * PSP Software Development Kit - http://www.pspdev.org
 * -----------------------------------------------------------------------
 * Licensed under the BSD license, see LICENSE in PSPSDK root for details.
 *
 * Copyright (c) 2005 Jesper Svennevid
 */

#include "vice.h"

#include <malloc.h>
#include <stdio.h>
#include <signal.h>
#include <string.h>

#include <stdlib.h> // Atoi

#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <pspgu.h>
#include <pspgum.h>

#include <stdarg.h> 


/* Define the module info section */
PSP_MODULE_INFO("PSPVice", 0, 1, 0); 

unsigned int __attribute__((aligned(16))) list[262144];
extern unsigned char logo_start[];

struct Vertex
{
	float u, v;
	unsigned int color;
	float x,y,z;
};

struct Vertex __attribute__((aligned(16))) vertices[12*3] =
{
	{0, 0, 0xff7f0000,-1,-1, 1}, // 0
	{1, 0, 0xff7f0000,-1, 1, 1}, // 4
	{1, 1, 0xff7f0000, 1, 1, 1}, // 5

	{0, 0, 0xff7f0000,-1,-1, 1}, // 0
	{1, 1, 0xff7f0000, 1, 1, 1}, // 5
	{0, 1, 0xff7f0000, 1,-1, 1}, // 1

	{0, 0, 0xff7f0000,-1,-1,-1}, // 3
	{1, 0, 0xff7f0000, 1,-1,-1}, // 2
	{1, 1, 0xff7f0000, 1, 1,-1}, // 6

	{0, 0, 0xff7f0000,-1,-1,-1}, // 3
	{1, 1, 0xff7f0000, 1, 1,-1}, // 6
	{0, 1, 0xff7f0000,-1, 1,-1}, // 7

	{0, 0, 0xff007f00, 1,-1,-1}, // 0
	{1, 0, 0xff007f00, 1,-1, 1}, // 3
	{1, 1, 0xff007f00, 1, 1, 1}, // 7

	{0, 0, 0xff007f00, 1,-1,-1}, // 0
	{1, 1, 0xff007f00, 1, 1, 1}, // 7
	{0, 1, 0xff007f00, 1, 1,-1}, // 4

	{0, 0, 0xff007f00,-1,-1,-1}, // 0
	{1, 0, 0xff007f00,-1, 1,-1}, // 3
	{1, 1, 0xff007f00,-1, 1, 1}, // 7

	{0, 0, 0xff007f00,-1,-1,-1}, // 0
	{1, 1, 0xff007f00,-1, 1, 1}, // 7
	{0, 1, 0xff007f00,-1,-1, 1}, // 4

	{0, 0, 0xff00007f,-1, 1,-1}, // 0
	{1, 0, 0xff00007f, 1, 1,-1}, // 1
	{1, 1, 0xff00007f, 1, 1, 1}, // 2

	{0, 0, 0xff00007f,-1, 1,-1}, // 0
	{1, 1, 0xff00007f, 1, 1, 1}, // 2
	{0, 1, 0xff00007f,-1, 1, 1}, // 3

	{0, 0, 0xff00007f,-1,-1,-1}, // 4
	{1, 0, 0xff00007f,-1,-1, 1}, // 7
	{1, 1, 0xff00007f, 1,-1, 1}, // 6

	{0, 0, 0xff00007f,-1,-1,-1}, // 4
	{1, 1, 0xff00007f, 1,-1, 1}, // 6
	{0, 1, 0xff00007f, 1,-1,-1}, // 5
};

int SetupCallbacks();

#define BUF_WIDTH (512)
#define SCR_WIDTH (480)
#define SCR_HEIGHT (272)
#define PIXEL_SIZE (4) /* change this if you change to another screenmode */
#define FRAME_SIZE (BUF_WIDTH * SCR_HEIGHT * PIXEL_SIZE)
#define ZBUF_SIZE (BUF_WIDTH SCR_HEIGHT * 2) /* zbuffer seems to be 16-bit? */


static int SubThread(SceSize args, void *argp)
{ 
  main_program(0, NULL);  
  return 0; // Exit thread
}


int main(int argc, char* argv[])
{
	//pspDebugScreenInit(); 
	
	SetupCallbacks();

  //printf("Program start");

	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG); 
	
	// setup GU

  /*
	sceGuInit();

	sceGuStart(GU_DIRECT,list);
	sceGuDrawBuffer(GU_PSM_8888,(void*)0,BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH,SCR_HEIGHT,(void*)0x88000,BUF_WIDTH);
	sceGuDepthBuffer((void*)0x110000,BUF_WIDTH);
	sceGuOffset(2048 - (SCR_WIDTH/2),2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048,2048,SCR_WIDTH,SCR_HEIGHT);
	sceGuDepthRange(0xc350,0x2710);
	sceGuScissor(0,0,SCR_WIDTH,SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST);
	sceGuDepthFunc(GU_GEQUAL);
	sceGuEnable(GU_DEPTH_TEST);
	sceGuFrontFace(GU_CW);
	sceGuShadeModel(GU_SMOOTH);
	sceGuEnable(GU_CULL_FACE);
	sceGuEnable(GU_TEXTURE_2D);
	sceGuEnable(GU_CLIP_PLANES);
	sceGuFinish();
	sceGuSync(0,0);

	sceDisplayWaitVblankStart();
	sceGuDisplay(GU_TRUE);
  */

	sceGuInit();
	
	sceGuStart(GU_DIRECT,list);
	sceGuDrawBuffer(GU_PSM_8888,(void*)0,BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH,SCR_HEIGHT,(void*)FRAME_SIZE,BUF_WIDTH);
	sceGuDepthBuffer((void*)(FRAME_SIZE*2),BUF_WIDTH);
	sceGuOffset(2048 - (SCR_WIDTH/2),2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048,2048,SCR_WIDTH,SCR_HEIGHT);
	sceGuDepthRange(0xc350,0x2710);
	sceGuScissor(0,0,SCR_WIDTH,SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST);

  //sceGuEnable( GU_BLEND );

	//sceGuAlphaFunc(GU_GREATER, 0x00 ,0xff); // Do this here, not in render loop ... This make crash !
	//sceGuEnable(GU_ALPHA_TEST); 
	sceGuDisable(GU_ALPHA_TEST); 

  sceGuDisable(GU_DEPTH_TEST);
  
  sceGuColor(0xFFFFFFFF);

	sceGuClearDepth(0);
	sceGuClearStencil(0); 	

	sceGuFinish();
	sceGuSync(0,0);


	sceDisplayWaitVblankStart();
	sceGuDisplay(GU_TRUE); 
	
	// run sample

  //printf("Launch emulator");

	//scePowerSetClockFrequency(333,333,166);
	//scePowerSetClockFrequency(222,222,111);

	//SceUID thid; 
	//thid = sceKernelCreateThread("subthread", SubThread, 17, 8192, THREAD_ATTR_USER, 0);
	//sceKernelStartThread(thid, 0, NULL); 
		
	//int val = 0;

  //sceKernelSleepThread();

  main_program(0, NULL); 

  while(1)
  {
  }

  /*
	for(;;)
	{
		sceGuStart(GU_DIRECT,list);

		// clear screen

		sceGuClearColor(0xff554433);
		sceGuClearDepth(0);
		sceGuClear(GU_COLOR_BUFFER_BIT|GU_DEPTH_BUFFER_BIT);

		sceGuFinish();
		sceGuSync(0,0);

		sceDisplayWaitVblankStart();
		sceGuSwapBuffers();

		val++;
	}
	*/

	sceGuTerm();

	sceKernelExitGame();
	return 0;
}

//#define LOGSIZE 1024*4
//extern short logck[LOGSIZE];

/* Exit callback */
int exit_callback(int arg1, int arg2, void *common)
{
	scePowerSetClockFrequency(222,222,111);

  // Save log
  /*
  SceUID fid;
  fid=sceIoOpen("ms0:/PSP/log1", PSP_O_WRONLY | PSP_O_CREAT, 0777);
  if (fid>=0)
  {
    sceIoWrite(fid, logck, LOGSIZE*2);
    sceIoClose(fid);
  } 
  */

	sceKernelExitGame();
	return 0;
}

/* Callback thread */
int CallbackThread(SceSize args, void *argp)
{
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);

	sceKernelSleepThreadCB();

	return 0;
}

/* Sets up the callback thread and returns its thread id */
int SetupCallbacks(void)
{
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
	if(thid >= 0)
	{
		sceKernelStartThread(thid, 0, 0);
	}

	return thid;
} 




char path_prefix[1024];

void graph_init()
{
}

void pcm_init()
{
}

void kbd_init()
{
}

extern FILE *tempfile[4];



void padopen();

void main_exit(void)
{
/*
    log_message(LOG_DEFAULT, "\nExiting...");

    machine_shutdown();

    putchar ('\n');
*/
}


extern FILE *tempfile[4];
    
FILE* fopen_(const char *c1, const char *d, int test)
{
  int byteread;
  int i,j;
  SceUID fid;

  //printf("Fopen File %s\n", c1);
  
  char fullname[512];
  char fullname1[512];
  
  strcpy(fullname1, "ms0:/PSP/Game/PSPVICE/");
  strcat(fullname1, c1);
  
  // Remove double //
  i=0;
  j=0;
  while(fullname1[i])
  {
    if ( !(fullname1[i]=='/' && fullname1[i+1]=='/' ) )
    {
      fullname[j]=fullname1[i];
      j++;
    }
    i++;
  }
  fullname[j]=0;
  
  printf("Fopen_ %s\n", fullname);
  
  FILE* mynew = (FILE*) malloc(sizeof(FILE));
  bzero((char*)mynew, sizeof(FILE));
  
  //printf ("opening '%s' '%s'\n", c, d);

  //if (!strncmp(c, "cdfs:", 5) || !strncmp(c, "cdrom0:", 7)) {
  //  cdvd_access();
  //}

  mynew->_ur = -1;   

  
  if (!strncmp(c1, "temp", 4))
  {
    mynew->_ur = atoi(c1+4);
  }

  if (mynew->_ur < -1 || mynew->_ur > 4)
  {
    free(mynew);
    return NULL;
  }
  

  mynew->_flags = 0;

  if (index(d, 'w')!=NULL || index(d, '+')!=NULL)
  {
    if (mynew->_ur==-1)
      mynew->_file = sceIoOpen(fullname, PSP_O_WRONLY | PSP_O_CREAT, 0777); 
    mynew->_flags |= 1;
    mynew->_r = 0;
    mynew->_offset = 0;
    mynew->_p = (char*) malloc(mynew->_r + 1);
    if (mynew->_ur!=-1)
    {
      if (tempfile[mynew->_ur]!=NULL)
      {
        free(tempfile[mynew->_ur]->_p);
        free(tempfile[mynew->_ur]);
      }
      tempfile[mynew->_ur]=mynew;
    }
    return mynew;
  }
  else
  {
    if (mynew->_ur!=-1)
    {
      free(mynew);
      if (tempfile[mynew->_ur]==NULL)
      {
        return NULL;
      }
      tempfile[mynew->_ur]->_offset = 0;
      tempfile[mynew->_ur]->_flags = 0;
      return tempfile[mynew->_ur];
    }
    
    fid = sceIoOpen(fullname, PSP_O_RDONLY, 0); 

    printf("Open return %d", fid);
    // Pb !!! sceIoOpen return 2 when file do not exists (should return >0)

    mynew->_file = fid;
  }

  if (mynew->_file<0)
  {
    printf("File not found exiting");
    free(mynew);
    return NULL;
  }
  
  
  if (test)
  {
    printf("File in test mode ... Test OK ... exiting");
    sceIoClose(mynew->_file); 
    free(mynew);
    return (FILE*)1;
  }
  

  // -- Compute size
  mynew->_r = sceIoLseek(mynew->_file, 0, SEEK_END); 
  mynew->_p = (char*) malloc(mynew->_r + 1);
  sceIoLseek(mynew->_file, 0, SEEK_SET); 
  mynew->_offset = 0;

  printf("Size of file %d", mynew->_r);

  if (mynew->_r < 0 || mynew->_p == NULL)
  {
   sceIoClose(mynew->_file); 
    if (mynew->_p != NULL)
      free(mynew->_p);
    free(mynew);
    return NULL;
  }

  // -- Read datas
  if (mynew->_r)
  {
    byteread = sceIoRead(mynew->_file, mynew->_p, mynew->_r);
    
    //printf("Byte read = %d", byteread);
    
    if (byteread!=mynew->_r)
    {
      sceIoClose(mynew->_file); 
      free(mynew->_p);
      free(mynew);
      return NULL;
    }
  }

  if (!(mynew->_flags & 1))
    sceIoClose(mynew->_file); 

  //printf("Fopen exiting");

  return mynew;
 
  // TODO CK
}

int MyPrintf(const char * string, ...)
{ 
    char localstring[256];
    va_list ap;
    va_start(ap, string);
    vsprintf(localstring, string, ap);
    pspDebugScreenPrintf(localstring);
    return 0; 
}